﻿using EmailClient.DomainModel.Component;

namespace EmailClient.DomainModel
{
    public class Email : ObservableObject
    {
        private string _recipient;
        private string _subject;
        private string _content;
        private DateTimeOffset _timestamp;
        private bool _isUnread;
        private string _sender;

        public Email(int id, string sender, string recipient, string subject, string content, DateTimeOffset timestamp, bool isUnread, DateTimeOffset lastSync)
        {
            Id = id;
            _sender = sender;
            _recipient = recipient;
            _subject = subject;
            _content = content;
            _timestamp = timestamp;
            _isUnread = isUnread;
            LastSync = lastSync;
        }

        internal int Id { get; }

        internal DateTimeOffset LastSync { get; set; }

        public string Sender
        {
            get => _sender;
            set => SetValue(ref _sender, ref value);
        }

        public string Recipient
        {
            get => _recipient;
            set => SetValue(ref _recipient, ref value);
        }

        public string Subject
        {
            get => _subject;
            set => SetValue(ref _subject, ref value);
        }

        public string Content
        {
            get => _content;
            set => SetValue(ref _content, ref value);
        }

        public DateTimeOffset Timestamp
        {
            get => _timestamp;
            internal set => SetValue(ref _timestamp, ref value);
        }

        public bool IsUnread
        {
            get => _isUnread;
            set => SetValue(ref _isUnread, ref value);
        }
    }
}
