using EmailClient.Data;
using EmailClient.MVP.Presenter;
using EmailClient.MVP.View;
using EmailClient.Transactional.Service;

namespace EmailClient.MVP
{
    internal static class Program
    {
        /// <summary>
        ///  The main entry point for the application.
        /// </summary>
        [STAThread]
        static void Main()
        {
            // To customize application configuration such as set high DPI settings or default font,
            // see https://aka.ms/applicationconfiguration.
            ApplicationConfiguration.Initialize();
            MailServer server = new MailServer("pawel.aszklar@pw.edu.pl");
            Account modelService = new Account(server);
            AccountView mainView = new AccountView();
            AccountPresenter presenter = new AccountPresenter(mainView, modelService);
            Application.Run(mainView);
        }
    }
}