﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using EmailClient.MVVM.ViewModel;
using EmailClient.MVVM.Views;

namespace EmailClient.MVVM.Services
{
    public class DialogService : IDialogService
    {
        private Dictionary<object, EmailDetailsView> _detailViews = new();
        private Dictionary<EmailViewModel, EmailEditView> _editViews = new();
        public void ShowDetails(EmailViewModel email)
        {
            if (_detailViews.TryGetValue(email, out var view))
                view.Activate();
            else
            {
                var w = new EmailDetailsView()
                {
                    DataContext = email,
                    Owner = Application.Current.MainWindow
                };
                _detailViews[email] = w;
                w.Closed += RemoveDetailsView;
                w.Show();
            }
        }

        private void RemoveDetailsView(object? sender, EventArgs e)
        {
            var w = (Window)sender!;
            _detailViews.Remove(w.DataContext);
            w.Closed -= RemoveDetailsView;
        }

        public void EditDetails(EmailViewModel email)
        {
            if (_editViews.TryGetValue(email, out var view))
                view.Activate();
            else
            {
                var w = new EmailEditView
                {
                    DataContext = email,
                    Owner = Application.Current.MainWindow
                };
                _editViews[email] = w;
                w.Closed += RemoveEditView;
                w.Show();
            }
        }

        private void RemoveEditView(object? sender, EventArgs e)
        {
            var w = (Window)sender!;
            _editViews.Remove((EmailViewModel)w.DataContext);
            w.Closed -= RemoveEditView;
        }
    }
}
