﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using EmailClient.Data;

namespace EmailClient.Monolith
{
    public partial class ViewEmailForm : Form
    {
        private readonly int _emailId;
        public ViewEmailForm(MailServer server, int emailId)
        {
            InitializeComponent();
            _emailId = emailId;
            var sender = server.GetEmailSender(_emailId).Result!;
            lblAddress.Text = sender == server.Address ? server.GetEmailRecipient(emailId).Result : sender;
            lblSubject.Text = server.GetEmailSubject(_emailId).Result;
            lblTimestamp.Text = server.GetEmailTimestamp(_emailId).Result.ToString("yyyy-MM-dd HH:mm");
            tbContent.Text = server.GetEmailContent(_emailId).Result;
        }

        private void btnClose_Click(object sender, EventArgs e)
        {
            Close();
        }

        private void btnReplyTo_Click(object sender, EventArgs e)
        {
            (Owner as MainWindow)?.ShowReplyEdit(_emailId);
        }

        private void btnForwardEmail_Click(object sender, EventArgs e)
        {
            (Owner as MainWindow)?.ShowReplyEdit(_emailId);
        }
    }
}
